/*
 * COPYRIGHT (c) International Business Machines Corp. 2023
 *
 * This program is provided under the terms of the Common Public License,
 * version 1.0 (CPL-1.0). Any use, reproduction or distribution for this
 * software constitutes recipient's acceptance of CPL-1.0 terms which can be
 * found in the file LICENSE file or at
 * https://opensource.org/licenses/cpl1.0.php
 */
/* AUTO-GENERATED on Mon Jan  9 13:16:08 2023.  DO NOT EDIT! */

#include <string.h>
#include <pkcs11types.h>
#include "mechtable.h"
#include "mechtable.inc"

static const unsigned char numericalphabet[] = {
  0, 1, 2, 3, 4, 5, 6, 7,
  0, 8, 9, 10, 11, 12, 13, 0,
  14, 15, 16, 0, 0, 0, 0, 0,
  0, 0, 0, 17, 18, 0, 19, 20,
  21, 22, 23, 24, 0, 25, 26, 27,
  28, 0, 0, 0, 0, 0, 0, 0,
  29, 30, 31, 32, 33, 34, 35, 36,
  37, 0, 0, 0, 0, 0, 0, 0,
  38, 39, 40, 41, 42, 43, 44, 45,
  46, 47, 48, 0, 49, 50, 51, 0,
  52, 53, 54, 55, 0, 56, 57, 58,
  0, 0, 0, 0, 0, 0, 0, 0,
  59, 60, 61, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  62, 63, 64, 0, 0, 0, 65, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  66, 67, 68, 69, 70, 71, 72, 73,
  0, 74, 75, 0, 0, 0, 0, 0,
  0, 0, 76, 77, 78, 79, 80, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  81, 0, 0, 0, 0, 0, 0, 0,
  82, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
};
static const short numerictable[] = {
  -68, -67, 159, -71, 3, -65, -78, -47,
  -69, -73, -72, -80, -70, -79, -35, -34,
  -37, -36, -33, 23, 4, -32, -31, 130,
  0, -62, -63, -64, 0, 2, 0, 0,
  -74, -75, -76, 0, 0, 0, -91, -97,
  -109, -92, -98, -110, -85, -86, -100, -101,
  -102, -103, -104, -105, -45, -39, -40, -41,
  -42, -43, -44, 0, 0, 0, 0, -87,
  -88, -89, -38, -81, -82, -83, -93, -94,
  -95, -99, -106, -107, 0, 0, 0, 0,
  -11, -9, -1, -12, -13, -2, -8, -10,
  -7, -6, -29, -28, -24, 0, -25, 18,
  0, 0, -15, -21, -20, -16, -22, -23,
  -17, -19, -18, -14, -4, -5, -3, -117,
  0, 0, 0, -46, 0, 0, 0, 0,
  0, -30, 0, -26, -27, -114, -112, -111,
  -116, -113, -115, -54, -56, -58, -60, 0,
  0, -48, 0, -77, -90, -96, -108, -84,
  -66, -118, 0, -50, -52, -51, -53, 0,
  0, 0, -49, -55, -57, -59, -61, 0,
  69, 11, 63, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 14, 0, 0,
  0, 0, 0, 0, 17, 103, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0,
};
int mechtable_idx_from_numeric(CK_ULONG mech)
{
    unsigned int idx1, idx2, idx3, idx4;
    int o1, o2, o3;
    int midx;

    idx1 = numericalphabet[(mech & 0xff000000u) >> 24u];
    idx2 = numericalphabet[(mech & 0x00ff0000u) >> 16u];
    idx3 = numericalphabet[(mech & 0x0000ff00u) >> 8u];
    idx4 = numericalphabet[mech & 0x000000ffu];
    o1 = numerictable[29 + idx1];
    if (o1 < 0) return -1;
    o2 = numerictable[o1 + idx2];
    if (o2 < 0) return -1;
    o3 = numerictable[o2 + idx3];
    if (o3 < 0) return -1;
    midx = numerictable[o3 + idx4];
    midx = -(midx + 1);
    if (0 <= midx && midx < 118 && mechtable_rows[midx].numeric == mech)
        return midx;
    return -1;
}

const struct mechrow *mechrow_from_numeric(CK_ULONG mech)
{
    int idx = mechtable_idx_from_numeric(mech);

    if (idx < 0)
        return NULL;
    return &mechtable_rows[idx];
}

static const unsigned char stringalphabet[] = {
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  1, 2, 3, 4, 5, 6, 7, 0,
  8, 9, 0, 0, 0, 0, 0, 0,
  0, 10, 11, 12, 13, 14, 15, 16,
  17, 18, 0, 19, 20, 21, 22, 23,
  24, 0, 25, 26, 27, 28, 29, 30,
  31, 32, 0, 0, 0, 0, 0, 33,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
};
static const short stringtable[] = {
  0, 0, 193, 84, 259, -50, 281, -51,
  75, 189, 28, 198, 182, 3, 159, 138,
  -46, 112, 167, 146, 129, 190, -15, 106,
  311, 183, 68, -116, 23, 160, -9, 128,
  -10, 218, 115, 304, -71, 124, 118, -14,
  89, 133, 44, -47, 121, -48, -49, 36,
  151, 184, -8, 20, 49, -20, 279, -34,
  -108, 193, -21, 169, 137, 4, 278, -28,
  3, -40, 174, -43, -29, -44, 93, 218,
  -30, -84, 233, 248, -90, -96, 188, 218,
  86, 188, 233, 248, -111, 209, 307, 233,
  82, -114, 246, -115, 281, -3, 293, 286,
  -31, -39, -4, -5, -45, -35, -32, -38,
  -62, 184, -36, -33, -37, -67, -68, -74,
  162, -65, -69, -70, -77, 214, -81, -87,
  -93, -99, 202, -100, -80, -103, 16, 128,
  -1, 91, 147, 120, 133, -6, 123, 136,
  -12, 88, 19, 39, 141, -16, 91, 133,
  204, 146, -18, 136, 149, -22, 155, 54,
  57, 58, 37, -24, 270, 152, 277, -26,
  -27, -2, 139, 145, 153, 141, -7, 135,
  83, -13, 55, 67, 97, 158, -17, 166,
  63, -41, 160, -19, -42, 150, -23, 33,
  154, 2, 180, -52, -25, -53, 187, 159,
  5, 194, -54, 196, -56, 193, 199, -58,
  198, 202, -60, 198, 104, 196, 195, 208,
  -63, 200, 178, 33, 201, 188, 109, 212,
  215, 218, -72, 0, 111, 201, 213, 212,
  225, -75, 97, -55, 220, -57, 198, 93,
  -59, 222, 210, -61, 237, -78, 118, 230,
  230, -64, 243, -82, 235, 213, 223, 229,
  237, 224, 252, -73, -85, 119, 245, 244,
  257, -88, -76, 250, 228, 238, 244, 252,
  239, 266, -91, 263, 120, 261, -79, 260,
  273, -94, 265, 244, -83, 254, 260, 268,
  255, 282, -97, 281, 121, -86, 123, 267,
  279, 279, -89, 292, -101, 125, 274, 286,
  285, 298, -104, -92, 291, 290, 303, -106,
  295, 274, -95, 284, 290, 298, 285, 312,
  -109, 310, 283, -98, 65, -112, 287, 288,
  -113, 307, -66, -11, 0, -102, 0, 0,
  0, 0, -118, -105, 0, 0, 0, 0,
  -107, -117, 0, 0, 0, 0, 0, 0,
  0, -110,
};
static const size_t commonprefixlength = 4;

int mechtable_idx_from_string(const char *mech)
{
    static const struct {
        const char *string;
        const char *alias;
    } aliaslist[] = {
        { "CKM_ECDSA_KEY_PAIR_GEN", "CKM_EC_KEY_PAIR_GEN" },
        { "CKM_IBM_EC_C25519", "CKM_IBM_EC_X25519" },
        { "CKM_IBM_EC_C448", "CKM_IBM_EC_X448" },
        { "CKM_IBM_EDDSA_SHA512", "CKM_IBM_ED25519_SHA512" },
    };
    size_t len = strlen(mech), i;
    short idx = 0;
    unsigned char h;

    for (i = commonprefixlength; i <= len; ++i) {
        h = stringalphabet[(int)mech[i]];
        idx = stringtable[idx + h];
        if (idx < 0) {
            idx = -(idx + 1);
            if (strcmp(mech, mechtable_rows[idx].string) == 0)
                return idx;
            goto outcheckaliases;
        }
    }
  outcheckaliases:
    for (i = 0; i < sizeof(aliaslist) / sizeof(aliaslist[0]); ++i) {
        if (strcmp(aliaslist[i].string, mech) == 0)
            return mechtable_idx_from_string(aliaslist[i].alias);
    }
    return -1;
}

const struct mechrow *mechrow_from_string(const char *mech)
{
    int idx = mechtable_idx_from_string(mech);

    if (idx < 0)
        return NULL;
    return &mechtable_rows[idx];
}

const struct mechtable_funcs mechtable_funcs = {
    .p_idx_from_num = &mechtable_idx_from_numeric,
    .p_idx_from_str = &mechtable_idx_from_string,
    .p_row_from_num = &mechrow_from_numeric,
    .p_row_from_str = &mechrow_from_string
};

